/***************************************************************************
                          BitOp.cpp  -  description
                             -------------------
    begin                : Thu Sep 6 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/
#include <stdio.h>
namespace rwil {
  namespace BitOp {

    void SetBit(char *data, int bit, int val)
    {
      int byte = bit/8;
      int loc = 7-bit%8;
      data[byte] = data[byte] & (~(1 << loc)) | (val << loc);
    }
 	
    void SetBits(char *data, int startbit, int numbits, int val)
    {
      int count;
      for(count=0;count<numbits;count++)
	{
	  //		printf("%d=", val & (1 << count));
	  SetBit(data, startbit+numbits- 1 - count, val & (1 << count)?1:0);
	}
      //	printf("\n");
    }

    int GetBit(char *data, int bit)
    {
      return data[bit/8] & (1 << (7-bit%8))?1:0;
    }

    int GetBits(char *data, int startbit, int numbits)
    {
      int count;
      int retval = 0;
      for(count=0;count<numbits;count++)
	{
	  retval += GetBit(data, startbit + numbits - count - 1) << count;
	}
      return retval;
    }

    void PrintBits(char *data, int bits)
    {
      int count;
      for(count=0;count<bits;count++)
	{
	  if(!(count%8)) printf("-");
	  printf("%d", data[count/8] & (1 << (7-count%8))?1:0);
	}
      printf("\n");
    }
  }
}
