/***************************************************************************
                          SerialOp.cpp  -  description
                             -------------------
    begin                : Thu Sep 6 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/
#include <fcntl.h> /* File control definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <stdio.h> /* Standard input/output definitions */

namespace rwil {
  namespace SerialOp {
    int fd = 0;
    /*
     * 'open_port()' - Open serial port 1.
     *
     * Returns the file descriptor on success or -1 on error.
     */

    void
    open_port(void)
    {
      //        int fd; /* File descriptor for the port */


      fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NONBLOCK);
      if (fd == -1)
        {
	  /*
	   * Could not open the port.
	   */

          perror("open_port: Unable to open /dev/ttyS0 - ");
        }
      else
	fcntl(fd, F_SETFL, 0);

      return;
    }
	
    void configure_port()
    {
      struct termios options;
	
      if(!fd) open_port();

      tcgetattr(fd, &options);
      cfsetispeed(&options, B9600);
      cfsetospeed(&options, B9600);

      options.c_cflag |= CLOCAL | CREAD;
      options.c_cflag &= ~CSIZE;
      options.c_cflag |= CS8;
      options.c_cflag &= ~PARENB;
      options.c_cflag &= ~CSTOPB;
	
      options.c_cflag &= ~CRTSCTS;

      options.c_lflag &= ~(ICANON | ECHO | ECHOE| ISIG );

      //disable software flow control
      options.c_iflag &= ~(IXON | IXOFF | IXANY);

      //disaable output mangling
      options.c_oflag &= ~OPOST;

      tcsetattr(fd, TCSAFLUSH, &options);
      fcntl(fd, F_SETFL, FNDELAY);
    }
  }

}
