/***************************************************************************
                          X10Interface.h  -  description
                             -------------------
    begin                : Tue Sep 4 2001
    copyright            : (C) 2001 by
    email                :
 ***************************************************************************/

/***************************************************************************
                          X10Interface.cpp  -  description
                             -------------------
    begin                : Tue Sep 4 2001
    copyright            : (C) 2001 by
    email                :
 ***************************************************************************/

namespace rwil {
#define CARRIAGE 0x0d
  /// This namespace contains functions for blocking access to the x10 network
  namespace X10 {
    /// Sends the initialize command to the PowerLinc. Automatically called by the other functions
    void send_init();

    /// Sends a simple X10 command
    void send_X10(char realhouse, char realnumber, char command);



    /*inputLength is in bits */
    /// Complement the the bits and add the signature as required
    int createCompAndAddSig(char* input, char *output, int inputlength);

    /// Send a dim command to a device
    void send_Dim_X10(char realhouse, char realnumber, int percent);

    /// Remove the signature and uncomplement the bits
    int stripSigAndCompress(char * input, char* output, int inputlength);

    /// Send an arbitrary  chunk of data to the PowerLinc
    void send_arbitrary(char data[10], int sizebits);

    /// Get the current status of a device
    int get_status_X10(char realhouse, char realnumber);

    //Read data from the X10 interface until either a Carriage return is found or the buffer is full
    //The function will demangle and strip the incoming data
    //bufsize is measured in bytes
    //the max buffer size supported is 100 bytes
    //Return value is the number of bits gathered
    /// Read data from the X10 interface until either a Carriage return is found or th ebuffer is full
    int readFromX10(char *buffer, int bufSize);
  }
}
